namespace ChoiceProj.Samples.MyModule
{
    public static class Program
    {
        public static void Main()
        {
            // Creating both choices 
            ChoiceProj.MyModule.Lunch myLunch = new ChoiceProj.MyModule.Lunch();
            myLunch.Item = "Chicken";
            myLunch.Fries = true;

            ChoiceProj.MyModule.Dinner myDinner = new ChoiceProj.MyModule.Dinner();
            myDinner.Entry = "Fish";
            myDinner.Drinks = 2;

            // Creating Order
            ChoiceProj.MyModule.Order myOrder = new ChoiceProj.MyModule.Order();

            // Selecting lunch
            myOrder.One.SetValue(myLunch);

            if (myOrder.IsOne())
            {
                System.Console.WriteLine("Enjoy your lunch.");
            }
            else if (myOrder.IsTwo())
            {
                System.Console.WriteLine("Enjoy your dinner.");
            }
            else
            {
                System.Console.WriteLine("No Order items selected. Nothing to encode.");
                return;
            }

            // encoding/decoding/printing 
            OSS.Asn1rt.IEncoder encoder = ChoiceProjFactory.CreateEncoder();

            encoder.Encode(myOrder);
            System.Console.WriteLine(OSS.Asn1rt.Util.ByteArray.ByteArrayToHexString(encoder.Data, " ", 32));
            // output a0 0c 80 07 43 68 69 63 6b 65 6e 81 01 ff

            OSS.Asn1rt.IDecoder decoder = ChoiceProjFactory.CreateDecoder();
            decoder.Decode(encoder.Data, myOrder);
            System.Console.WriteLine(myOrder);
            // output
            // value Order ::= day : {
            //   item "Chicken",
            //   fries TRUE
            // }
        }
    }
}
